| OpenCV 3.4.7 Open Source Computer Vision

Classes | Public Types | Public Member Functions | List of all members
cvflann::KDTreeIndex< Distance > Class Template Reference

`#include <opencv2/flann/kdtree_index.h>`

Inheritance diagram for cvflann::KDTreeIndex< Distance >:

## Public Types
typedef Distance::ResultType | DistanceType
typedef Distance::ElementType | ElementType

## Public Member Functions
| KDTreeIndex (const Matrix< ElementType > &inputData, const IndexParams &params=KDTreeIndexParams(), Distance d=Distance())
| KDTreeIndex (const KDTreeIndex &)
| ~KDTreeIndex ()
void | buildIndex () CV_OVERRIDE
void | findNeighbors (ResultSet< DistanceType > &result, const ElementType *vec, const SearchParams &searchParams) CV_OVERRIDE
IndexParams | getParameters () const CV_OVERRIDE
flann_algorithm_t | getType () const CV_OVERRIDE
void | loadIndex (FILE *stream) CV_OVERRIDE
| Loads the index from a stream. More...
KDTreeIndex & | operator= (const KDTreeIndex &)
void | saveIndex (FILE *stream) CV_OVERRIDE
| Saves the index to a stream. More...
size_t | size () const CV_OVERRIDE
int | usedMemory () const CV_OVERRIDE
size_t | veclen () const CV_OVERRIDE
Public Member Functions inherited from cvflann::NNIndex< Distance >
virtual | ~NNIndex ()
virtual void | knnSearch (const Matrix< ElementType > &queries, Matrix< int > &indices, Matrix< DistanceType > &dists, int knn, const SearchParams &params)
| Perform k-nearest neighbor search. More...
virtual int | radiusSearch (const Matrix< ElementType > &query, Matrix< int > &indices, Matrix< DistanceType > &dists, float radius, const SearchParams &params)
| Perform radius search. More...

## Detailed Description

### template<typename Distance>
class cvflann::KDTreeIndex< Distance >

Randomized kd-tree index

Contains the k-d trees and other information for indexing a set of points for nearest-neighbor matching.

## Member Typedef Documentation

## § DistanceType

template<typename Distance>

typedef Distance::ResultType cvflann::KDTreeIndex< Distance >::DistanceType

## § ElementType

template<typename Distance>

typedef Distance::ElementType cvflann::KDTreeIndex< Distance >::ElementType

## Constructor & Destructor Documentation

## § KDTreeIndex() [1/2]

template<typename Distance>

cvflann::KDTreeIndex< Distance >::KDTreeIndex | ( | const Matrix< ElementType > & | inputData,
|  | const IndexParams & | params = `KDTreeIndexParams()`,
|  | Distance | d = `Distance()`
| ) |  |
| inline

KDTree constructor

Params: inputData = dataset with the input features params = parameters passed to the kdtree algorithm

## § KDTreeIndex() [2/2]

template<typename Distance>

cvflann::KDTreeIndex< Distance >::KDTreeIndex | ( | const KDTreeIndex< Distance > & |  | ) |

## § ~KDTreeIndex()

template<typename Distance>

cvflann::KDTreeIndex< Distance >::~KDTreeIndex | ( |  | ) |
| inline

Standard destructor

## Member Function Documentation

## § buildIndex()

template<typename Distance>

void cvflann::KDTreeIndex< Distance >::buildIndex | ( |  | ) |
| inline virtual

Builds the index

Implements cvflann::NNIndex< Distance >.

## § findNeighbors()

template<typename Distance>

void cvflann::KDTreeIndex< Distance >::findNeighbors | ( | ResultSet< DistanceType > & | result,
|  | const ElementType * | vec,
|  | const SearchParams & | searchParams
| ) |  |
| inline virtual

Find set of nearest neighbors to vec. Their indices are stored inside the result object.

Params: result = the result object in which the indices of the nearest-neighbors are stored vec = the vector for which to search the nearest neighbors maxCheck = the maximum number of restarts (in a best-bin-first manner)

Implements cvflann::NNIndex< Distance >.

## § getParameters()

template<typename Distance>

IndexParams cvflann::KDTreeIndex< Distance >::getParameters | ( |  | ) | const
| inline virtual

Returns
  The index parameters

Implements cvflann::NNIndex< Distance >.

## § getType()

template<typename Distance>

flann_algorithm_t cvflann::KDTreeIndex< Distance >::getType | ( |  | ) | const
| inline virtual

Returns
  The index type (kdtree, kmeans,...)

Implements cvflann::NNIndex< Distance >.

## § loadIndex()

template<typename Distance>

void cvflann::KDTreeIndex< Distance >::loadIndex | ( | FILE * | stream | ) |
| inline virtual

Loads the index from a stream.

Parameters

  stream | The stream from which the index is loaded

Implements cvflann::NNIndex< Distance >.

## § operator=()

template<typename Distance>

KDTreeIndex& cvflann::KDTreeIndex< Distance >::operator= | ( | const KDTreeIndex< Distance > & |  | ) |

## § saveIndex()

template<typename Distance>

void cvflann::KDTreeIndex< Distance >::saveIndex | ( | FILE * | stream | ) |
| inline virtual

Saves the index to a stream.

Parameters

  stream | The stream to save the index to

Implements cvflann::NNIndex< Distance >.

## § size()

template<typename Distance>

size_t cvflann::KDTreeIndex< Distance >::size | ( |  | ) | const
| inline virtual

Returns size of index.

Implements cvflann::NNIndex< Distance >.

## § usedMemory()

template<typename Distance>

int cvflann::KDTreeIndex< Distance >::usedMemory | ( |  | ) | const
| inline virtual

Computes the inde memory usage Returns: memory used by the index

Implements cvflann::NNIndex< Distance >.

## § veclen()

template<typename Distance>

size_t cvflann::KDTreeIndex< Distance >::veclen | ( |  | ) | const
| inline virtual

Returns the length of an index feature.

Implements cvflann::NNIndex< Distance >.

The documentation for this class was generated from the following file:

- opencv2/flann/kdtree_index.h